// DFPlayer Blog Crash Car
// This example uses SoftwareSerial to communnicate with DFPlayer...
// Requires 3.3V TTL level RX/TX such as Ardiuno Mini Pro (8Mhz, 3.3V)
// can use 5V/3.3V level shifter or try 1K ohm resistor on TX line 
// Arduino RX pin 16 connected to DFPlayer's TX pin 3
// Arduino TX pin 17 connected to DFPlayer's RX pin 2
// Arduino    pin 15 connected to DFPlayer's BUSY pin 16
// Arduino    pin 14 connected to Microswitches in parallel
//
// ******** UNLESS YOU WANT ALL CV'S RESET UPON EVERY POWER UP
// ******** AFTER THE INITIAL DECODER LOAD REMOVE THE "//" IN THE FOOLOWING LINE!!
//#define DECODER_LOADED

#include <NmraDcc.h>
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>

const int FunctionPin0 = 3;
const int FunctionPin1 = 4;
const int FunctionPin2 = 5;
const int FunctionPin3 = 6;
const int FunctionPin4 = 7;

const int FunctionPin5 = 8;
const int FunctionPin6 = 9;
const int FunctionPin7 = 10;
const int FunctionPin8 = 11;

const int FunctionPin9 = 12;
const int FunctionPin10 = 13;
const int FunctionPin11 = 14;     //A0
const int FunctionPin12 = 15;     //A1

const int FunctionPin13 = 16;     //A2
const int FunctionPin14 = 17;     //A3
const int FunctionPin15 = 18;     //A4
const int FunctionPin16 = 19;     //A5

int F0 = 1;   //  Start F0 = ON

NmraDcc  Dcc ;
DCC_MSG  Packet ;
SoftwareSerial mp3Serial(16, 17);  // RX, TX
int del_tim = 20; 
#define busy_pin 15
#define crash_pin 14
int DFPlayer_VolumeSetting = 26; //  Set volume to 18 (0-30 range)
int delta = 100;
int ttemp;
boolean twait = LOW;
//
#define This_Decoder_Address 24
uint8_t CV_DECODER_MASTER_RESET = 120;
extern uint8_t Decoder_Address = This_Decoder_Address;
struct CVPair
{
  uint16_t  CV;
  uint8_t   Value;
};
CVPair FactoryDefaultCVs [] =
{
  {CV_MULTIFUNCTION_PRIMARY_ADDRESS, This_Decoder_Address},
  {CV_ACCESSORY_DECODER_ADDRESS_MSB, 0},
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_MSB, 0},
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_LSB, 0},
  {CV_DECODER_MASTER_RESET, 0},
};

uint8_t FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs)/sizeof(CVPair);
void notifyCVResetFactoryDefault()
{
  // Make FactoryDefaultCVIndex non-zero and equal to num CV's to be reset 
  // to flag to the loop() function that a reset to Factory Defaults needs to be done
  FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs)/sizeof(CVPair);
};
void setup () {
    int i;
    uint8_t cv_value;

  // Setup which External Interrupt, the Pin it's associated with that we're using 
  Dcc.pin(0, 2, 0);
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 100, FLAGS_MY_ADDRESS_ONLY, 0 );
  delay(800);

  #if defined(DECODER_LOADED)
  if ( Dcc.getCV(CV_DECODER_MASTER_RESET)== CV_DECODER_MASTER_RESET ) 
  #endif  
    {
     for (int j=0; j < FactoryDefaultCVIndex; j++ )
       Dcc.setCV( FactoryDefaultCVs[j].CV, FactoryDefaultCVs[j].Value);
    }

    pinMode (busy_pin, INPUT_PULLUP);
    pinMode (crash_pin, INPUT_PULLUP);
    pinMode (FunctionPin10, OUTPUT);
    mp3Serial.begin (9600);
    mp3_set_serial (mp3Serial);	//set softwareSerial for DFPlayer-mini mp3 module 
    delay(del_tim);
    mp3_stop ();
    delay(del_tim);
    mp3_set_volume (DFPlayer_VolumeSetting);
    delay(del_tim);
    mp3_set_EQ (2); //2
    delay (1300);
}
void loop () {
  //MUST call the NmraDcc.process() method frequently 
  // from the Arduino loop() function for correct library operation

  Dcc.process();
  if ((digitalRead (crash_pin)==LOW) && (F0==1)) {
    mp3_play_physical (random(1,11)) ;
    delay(del_tim);
    while (digitalRead (busy_pin)==twait) { ttemp=delta; } //Dcc.process();
    //mp3_stop ();
    delay(del_tim);
  }
  //mp3_reset ();
  //delay (1000);
}
/*
   mp3_play ();		//start play
   mp3_play (5);	//play "mp3/0005.mp3"
   mp3_next ();		//play next 
   mp3_prev ();		//play previous
   mp3_set_volume (uint16_t volume);	//0~30
   mp3_set_EQ ();	//0~5
   mp3_pause ();
   mp3_stop ();
   void mp3_get_state (); 	//send get state command
   void mp3_get_volume (); 
   void mp3_get_u_sum (); 
   void mp3_get_tf_sum (); 
   void mp3_get_flash_sum (); 
   void mp3_get_tf_current (); 
   void mp3_get_u_current (); 
   void mp3_get_flash_current (); 
   void mp3_single_loop (boolean state);	//set single loop 
   void mp3_DAC (boolean state); 
   void mp3_random_play (); 
 */
extern void notifyDccFunc( uint16_t Addr, FN_GROUP FuncGrp, uint8_t FuncState)  {
switch(FuncGrp)
  {
  case FN_0_4:    //Function Group 1 F0 F4 F3 F2 F1
    if (((FuncState & FN_BIT_00)>>4 ) == 0x01 ) F0 = 1;
      else  F0 = 0;

    //exec_function( 1, FunctionPin1, (FuncState & FN_BIT_01));
    //exec_function( 2, FunctionPin2, (FuncState & FN_BIT_02)>>1);
    // exec_function( 3, FunctionPin3, (FuncState & FN_BIT_03)>>2 );
    //exec_function( 4, FunctionPin4, (FuncState & FN_BIT_04)>>3 );
      break;
  /*  
  case FN_5_8:    //Function Group 1 S FFFF == 1 F8 F7 F6 F5  &  == 0  F12 F11 F10 F9 F8
      exec_function( 5, FunctionPin5, (FuncState & FN_BIT_05));
    exec_function( 6, FunctionPin6, (FuncState & FN_BIT_06)>>1 );
    exec_function( 7, FunctionPin7, (FuncState & FN_BIT_07)>>2 );
    exec_function( 8, FunctionPin8, (FuncState & FN_BIT_08)>>3 );
    break;
    
  case FN_9_12:
    exec_function( 9, FunctionPin9,   (FuncState & FN_BIT_09));
    exec_function( 10, FunctionPin10, (FuncState & FN_BIT_10)>>1 );
    exec_function( 11, FunctionPin11, (FuncState & FN_BIT_11)>>2 );
    exec_function( 12, FunctionPin12, (FuncState & FN_BIT_12)>>3 );
    break;

  case FN_13_20:   //Function Group 2 FuncState == F20-F13 Function Control
      exec_function( 13, FunctionPin13, (FuncState & FN_BIT_13));
    exec_function( 14, FunctionPin14, (FuncState & FN_BIT_14)>>1 );
    exec_function( 15, FunctionPin15, (FuncState & FN_BIT_15)>>2 );
    exec_function( 16, FunctionPin16, (FuncState & FN_BIT_16)>>3 );
      break;
  
  case FN_21_28:
      break;  
   */
  }
}

